'PSB Paint Demo (C) Copyright 2009 Rayslogic.com, LLC
' A simple paint app demo for the PSB showing graphics and touchscreen interface

CON

  _clkmode = term#_clkmode
  _xinfreq = term#_xinfreq


  'LCD is 480x272 giving 30x17 tiles
  cols = 30
  rows = 17
  screensize = cols * rows
    
  buffersize=480*16  '16 full rows of pixels
  buffersectors=buffersize/512
  bufferlongs= buffersize/4  'size of buffer in longs


VAR

  long  lcd_status      'status: off/visible/invisible  read-only       (5 contiguous longs)
  long  lcd_enable      'enable: off/on                 write-only
  long  lcd_videobase   'video base @word               write-only
  long  lcd_colorbase   'color base @long               write-only
  long  lcd_backlight   'Used to control LCD backlight
  long  lcd_6BitAddress  'address of 6-bit bitmap buffer

  word  screen[screensize]
  long  col, row, color
  long  boxcolor,ptr

  long BufferFlag
  long Buffer[bufferlongs]  
  



OBJ
  term: "sysdep"
  sd:"fsrw6"

pub Main |x,y,i,j
  term.start
  if sd.mount_explicit(term#sd_DO,term#sd_CLK,term#sd_DI,term#sd_CS)<0
    repeat
  if sd.popen(STRING("speed.tst"),"r")<0 
    repeat

    
  i:=@buffer
  sd.pread6(i,buffersectors)  
  BufferFlag:=1

  'start buffer fill loop
  repeat
    j := cnt
    repeat 16
      sd.pread6(i,buffersectors)
      bufferFlag:=1 


    'start over 
    sd.seek(0)
    sd.pread6(i,buffersectors)
    'bufferFlag:=1
    j := cnt - j
    term.dec(j)
    term.tx(10)
      
  repeat
